﻿Module askin
    Public Const DefaultSkin = "default" ' Name des Standart-Skins
    Public Const SkinsDir = "skins" ' Angabe ohne "\"; Ordner, in dem die Skins liegen
    Public Const DefautSkinInfoFile = "skin.xml" ' Name einer XML-Datei mit Informationen zum Skin.

    Public Structure sSkinModul
        Dim ModulName As String
        Dim ModulCode As List(Of String) ' Enthält die einzelnen Codezeilen des Moduls
    End Structure
    Public SkinModuls As New List(Of sSkinModul) ' Enhält die einzelnen Codemodule des Skins

    Public Structure sSkinObjectProbs
        Dim ClickEvent As String ' GUI-Befehl der ausgeführt wird, wenn auf das Objekt geklickt wird
        Dim ObjectType As String ' Name des Objekttyps
        Dim ObjectIndex As Integer ' Index.
        Dim GUILink As String ' String-ID, dient dazu, ein Objekt mit der GUI direkt zu "verknüpfen"
        Dim ObjectName As String ' Name des Objekts
        Dim ObjectReference As Object ' Das eigentliche Objekt als Referenz (z.B. ein Button)
        Dim ParentWindow As Form ' Das Form, auf dem das Objekt liegt (sofern es nicht selbst ein Form ist)
    End Structure
    Public SkinObjects As New List(Of sSkinObjectProbs)

    Public Structure sSkinInfos
        Dim Title As String
        Dim PreviewPicture As String
        Dim Author As String
        Dim Info As String
        Dim InfoFile As String
    End Structure

    Public Buttons As New List(Of Windows.Forms.Button)
    Public SkinButtons As New List(Of SkinButton.SkinButton)
    Public SkinPictures As New List(Of SkinPicture.SkinPicture)
    Public SkinLabels As New List(Of SkinLabel.SkinLabel)
    Public SkinProgressBars As New List(Of SkinProgressBar.SkinProgressBar)
    Public Skinname As String = DefaultSkin ' Name des akt. Skins; entspricht dem Ordnername, in dem sich der Skin befindet.
    Public SkinCode() As String ' Speichert temporär den Skriptcode. Eigentlicher Zugriff erfolgt über: SkinModuls
    Public SkinStartupModulID As Integer = IsVoid ' IsVoid = unbelegt
    Public CurWindowName As String ' Form, auf dem der Scriptcode momentan arbeitet (Name)
    Public CurWindow As Windows.Forms.Form ' Form, auf dem der Scriptcode momentan arbeitet (Objekt-Referenz)

    ' Lädt einen Skin und sorgt für die Ausführung des Startup-Skin-Moduls.
    ' Der Name des Skins muss vorher durch die Variable Skinname festgelegt werden.
    Public Function LoadSkin(Optional ByVal mySkinname As String = "") As Boolean
        Dim SkinModul As sSkinModul

        If Not mySkinname = "" Then Skinname = mySkinname
        Log("LoadSkin", Loc("Lade Skin. ") + " (" + Skinname + ")")

        If Not My.Computer.FileSystem.DirectoryExists(AppPath + "\" + SkinsDir + "\" + Skinname) Then
            Log(Loc("Fehler: Ausgewählter Skin konnte nicht gefunden werden.") + " (" + Skinname + ")")
            MsgBox(Loc("Fehler: Ausgewählter Skin konnte nicht gefunden werden."))
            Return False
        End If
        If Not My.Computer.FileSystem.FileExists(AppPath + "\" + SkinsDir + "\" + Skinname + "\startup.as") Then
            Log(Loc("Fehler: Skin-Startdatei konnte nicht gefunden werden.") + " (" + Skinname + ")")
            MsgBox(Loc("Fehler: Skin-Startdatei konnte nicht gefunden werden."))
            Return False
        End If

        ResetSkin()

        SkinCode = IO.File.ReadAllLines(AppPath + "\" + SkinsDir + "\" + Skinname + "\startup.as")

        For i = 0 To SkinCode.GetUpperBound(0)
            SkinCode(i) = Trim(SkinCode(i))

            If SkinCode(i).StartsWith("[") Then
                SkinModul = New sSkinModul
                SkinModul.ModulName = ParseMid(SkinCode(i), "[", "]")
                SkinModul.ModulCode = New List(Of String)
                SkinModuls.Add(SkinModul)
                If SkinModul.ModulName.ToUpper = "STARTUP" Then SkinStartupModulID = SkinModuls.Count - 1
            Else
                If Not (SkinCode(i).StartsWith("'") Or SkinModuls.Count = 0 Or SkinCode(i) = "") Then
                    SkinModul = SkinModuls(SkinModuls.Count - 1)
                    SkinModul.ModulCode.Add(SkinCode(i))
                    SkinModuls(SkinModuls.Count - 1) = SkinModul
                End If
            End If
        Next

        If EnableConsole Then frmConsole.UpdateSkript()

        RunSkinModul(SkinStartupModulID, frmAudia)

        Log("LoadSkin", Loc("Skin wurde geladen.") + " (" + Skinname + ")")
        Return True
    End Function

    ' Entfernt den aktuellen Skin.
    Public Sub ResetSkin()
        frmAudia.BackgroundImage = Nothing

        For Each myObject In Buttons
            myObject.Dispose()
        Next
        Buttons = New List(Of Windows.Forms.Button)

        For Each myObject In SkinButtons
            myObject.Dispose()
        Next
        SkinButtons = New List(Of SkinButton.SkinButton)

        For Each myObject In SkinPictures
            myObject.Dispose()
        Next
        SkinPictures = New List(Of SkinPicture.SkinPicture)

        For Each myObject In SkinLabels
            myObject.Dispose()
        Next
        SkinLabels = New List(Of SkinLabel.SkinLabel)

        For Each myObject In SkinProgressBars
            myObject.Dispose()
        Next
        SkinProgressBars = New List(Of SkinProgressBar.SkinProgressBar)

        SkinStartupModulID = IsVoid
        Erase SkinCode
        CurWindowName = ""
        CurWindow = Nothing
        SkinObjects = New List(Of sSkinObjectProbs)
        SkinModuls = New List(Of sSkinModul)
    End Sub

    ' Führt ein Skin-Modul aus. (Also Skriptcode!)
    Public Sub RunSkinModul(ByVal ModulID As Integer, ByVal Window As Form)
        Dim CurLineNr As Integer = IsVoid
        Dim CurLine As String

        Do
            CurLineNr += 1
            CurLine = SkinModuls(ModulID).ModulCode(CurLineNr)
            If ExecScriptCommand(CurLine, Window) = -1 Then Exit Do
        Loop Until CurLineNr >= SkinModuls(ModulID).ModulCode.Count - 1
    End Sub

    ' Führt einen einzelnen Skript-Befehl aus.
    Public Function ExecScriptCommand(ByVal ScriptCommand As String, Optional ByVal Window As Windows.Forms.Form = Nothing) As Integer
        Dim MidPart As String, Part1 As String, Part2 As String
        Dim Objectname As String, Propertyname As String
        Dim Index As Integer = -1

        IO.Directory.SetCurrentDirectory(AppPath + "\" + SkinsDir + "\" + Skinname + "\")

        Select Case ParseLeft(ScriptCommand, "(").ToUpper
            Case "SETWINDOW"
                MidPart = ConvertToRealString(ParseMid(ScriptCommand, "(", ")")).ToUpper
                Select Case MidPart
                    Case "PLAYER"
                        If GetSkinObjectID_byTypeAndName("Window", "Player") = -1 Then
                            Dim mySkinObjectProbs As New sSkinObjectProbs
                            mySkinObjectProbs.ObjectType = "Window"
                            mySkinObjectProbs.ObjectName = "Player"
                            mySkinObjectProbs.ObjectReference = frmAudia
                            SkinObjects.Add(mySkinObjectProbs)
                        End If
                        CurWindowName = "Player"
                        CurWindow = frmAudia
                    Case "NOTIFIER"
                        CurWindowName = "Notifier"
                        CurWindow = frmNotifier
                    Case Else
                        ' Fehler: Das Fenster bzw. der Fenstertyp existiert nicht
                        Log("ExecScriptCommand", Loc("Fehler: Das Fenster bzw. der Fenstertyp existiert nicht.") + " (" + MidPart + ")", True)
                End Select
            Case "SETPROPERTY"
                MidPart = ParseMid(ScriptCommand, "(", ")")
                Part1 = ParseLeft(MidPart, ",")
                Part2 = ParseRight(MidPart, ",")
                If InStr(Part1, "[") > 0 Then
                    Try
                        Index = CInt(ParseMid(Part1, "[", "]"))
                        Objectname = ParseLeft(Part1, "[").ToUpper
                        Propertyname = Mid(ParseRight(Part1, "]"), 2).ToUpper
                    Catch ex As Exception
                        ' Fehlende Index-Angabe
                        Log("ExecScriptCommand", Loc("Fehler: Fehlende Index-Angabe."), True)
                    End Try
                Else
                    Objectname = ParseLeft(Part1, ".").ToUpper
                    Propertyname = ParseRight(Part1, ".").ToUpper
                    Index = -1
                End If
                Try
                    Select Case Propertyname
                        Case "XPOS"
                            If Objectname = "WINDOW" Then CurWindow.Location = New Point(CInt(Part2), CurWindow.Location.Y)
                            If Objectname = "BUTTON" Or Objectname = "SKINBUTTON" Or Objectname = "SKINPICTURE" Or Objectname = "SKINLABEL" Or Objectname = "SKINPROGRESSBAR" Then
                                GetGUIObject_ByName(Objectname, Index).Location = New Point(CInt(Part2), GetGUIObject_ByName(Objectname, Index).Location.Y)
                            End If
                        Case "YPOS"
                            If Objectname = "WINDOW" Then CurWindow.Location = New Point(CurWindow.Location.Y, CInt(Part2))
                            If Objectname = "BUTTON" Or Objectname = "SKINBUTTON" Or Objectname = "SKINPICTURE" Or Objectname = "SKINLABEL" Or Objectname = "SKINPROGRESSBAR" Then
                                GetGUIObject_ByName(Objectname, Index).Location = New Point(GetGUIObject_ByName(Objectname, Index).Location.X, CInt(Part2))
                            End If
                        Case "WIDTH"
                            If Objectname = "WINDOW" Then CurWindow.Width = CInt(Part2)
                            If Objectname = "BUTTON" Then
                                GetGUIObject_ByName(Objectname, Index).Width = CInt(Part2)
                            End If
                        Case "HEIGHT"
                            If Objectname = "WINDOW" Then CurWindow.Height = CInt(Part2)
                            If Objectname = "BUTTON" Then
                                GetGUIObject_ByName(Objectname, Index).Height = CInt(Part2)
                            End If
                        Case "CLICKEVENT" ' Befehl, der beim Klick auf das Objekt ausgeführt wird
                            If Objectname = "WINDOW" Then
                                Index = GetSkinObjectID_byReference(Window)
                                If Index = -1 Then
                                    ' Fehler: Objekt nicht gefunden
                                Else
                                    Dim mySkinObjectProbs = SkinObjects(Index)
                                    mySkinObjectProbs.ClickEvent = ConvertToRealString(Part2)
                                    SkinObjects(Index) = mySkinObjectProbs
                                End If
                            End If
                            If Objectname = "BUTTON" Or Objectname = "SKINBUTTON" Or Objectname = "SKINPICTURE" Or Objectname = "SKINLABEL" Or Objectname = "SKINPROGRESSBAR" Then
                                Index = GetSkinObjectID_byObjectIndex(Objectname, Index)
                                If Index = -1 Then
                                    ' Fehler: Objekt nicht gefunden
                                    Log("ExecScriptCommand", Loc("Fehler: Obekt nicht gefunden.") + " (" + Objectname + ")", True)
                                Else
                                    Dim mySkinObjectProbs = SkinObjects(Index)
                                    mySkinObjectProbs.ClickEvent = ConvertToRealString(Part2)
                                    SkinObjects(Index) = mySkinObjectProbs
                                End If
                            End If
                        Case "FONTNAME"
                            If Objectname = "BUTTON" Then
                                Dim myButton = Buttons(Index)
                                myButton.Font = New Font(ConvertToRealString(Part2), myButton.Font.Size)
                                Buttons(Index) = myButton
                            End If
                            If Objectname = "SKINBUTTON" Then
                                GetGUIObject_ByName(Objectname, Index).ButtonTextFontname = ConvertToRealString(Part2)
                            End If
                            If Objectname = "SKINLABEL" Then
                                GetGUIObject_ByName(Objectname, Index).TextFontname = ConvertToRealString(Part2)
                            End If
                        Case "FONTSIZE"
                            If Objectname = "BUTTON" Then
                                Dim myButton = Buttons(Index)
                                myButton.Font = New Font(myButton.Font.FontFamily, Val(Part2))
                                Buttons(Index) = myButton
                            End If
                            If Objectname = "SKINBUTTON" Then
                                GetGUIObject_ByName(Objectname, Index).ButtonTextFontsize = Val(Part2)
                            End If
                            If Objectname = "SKINLABEL" Then
                                GetGUIObject_ByName(Objectname, Index).TextFontsize = Val(Part2)
                            End If
                        Case "GUILINK"
                            If Objectname = "WINDOW" Then Log("ExecScriptCommand", Loc("Fenster unterstützen die Eigenschaft GUILink nicht."), True)
                            If Objectname = "BUTTON" Or Objectname = "SKINBUTTON" Or Objectname = "SKINPICTURE" Or Objectname = "SKINLABEL" Or Objectname = "SKINPROGRESSBAR" Then
                                Index = GetSkinObjectID_byObjectIndex(Objectname, Index)
                                If Index = -1 Then
                                    ' Fehler: Objekt nicht gefunden
                                    Log("ExecScriptCommand", Loc("Fehler: Obekt nicht gefunden.") + " (" + Objectname + ")", True)
                                Else
                                    Dim mySkinObjectProbs = SkinObjects(Index)
                                    mySkinObjectProbs.GUILink = ConvertToRealString(Part2).ToUpper
                                    SkinObjects(Index) = mySkinObjectProbs
                                End If
                            End If
                        Case "MAXPOSITION"
                            If Objectname = "SKINPROGRESSBAR" Then
                                GetGUIObject_ByName(Objectname, Index).MaxPosition = New Point(CInt(ParseLeft(ConvertToRealString(Part2), ",")), CInt(ParseRight(ConvertToRealString(Part2), ",")))
                            End If
                        Case "MINPOSITION"
                            If Objectname = "SKINPROGRESSBAR" Then
                                GetGUIObject_ByName(Objectname, Index).MinPosition = New Point(CInt(ParseLeft(ConvertToRealString(Part2), ",")), CInt(ParseRight(ConvertToRealString(Part2), ",")))
                            End If
                        Case "MODE"
                            If Objectname = "SKINPROGRESSBAR" Then
                                GetGUIObject_ByName(Objectname, Index).Mode = CInt(Part2)
                            End If
                        Case "REVERSED"
                            If Objectname = "SKINPROGRESSBAR" Then
                                GetGUIObject_ByName(Objectname, Index).Reversed = CBool(Part2)
                            End If
                        Case "PICTURE"
                            If Objectname = "WINDOW" Then CurWindow.BackgroundImage = New Drawing.Bitmap(ConvertToRealString(Part2))
                            If Objectname = "SKINBUTTON" Then
                                Dim mySkinButton = SkinButtons(Index)
                                mySkinButton.SkinPictureFile = ConvertToRealString(Part2)
                                mySkinButton.Width = mySkinButton.SkinPictureWidth
                                mySkinButton.Height = mySkinButton.SkinPictureHeight
                                SkinButtons(Index) = mySkinButton
                            End If
                            If Objectname = "SKINPICTURE" Then
                                Dim mySkinPicture = SkinPictures(Index)
                                mySkinPicture.SkinPictureFile = ConvertToRealString(Part2)
                                mySkinPicture.Width = mySkinPicture.SkinPictureWidth
                                mySkinPicture.Height = mySkinPicture.SkinPictureHeight
                                SkinPictures(Index) = mySkinPicture
                            End If
                            If Objectname = "SKINLABEL" Then
                                Dim mySkinLabel = SkinLabels(Index)
                                mySkinLabel.ContainerImage = ConvertToRealString(Part2)
                                SkinLabels(Index) = mySkinLabel
                            End If
                            If Objectname = "SKINPROGRESSBAR" Then
                                GetGUIObject_ByName(Objectname, Index).PictureBar = ConvertToRealString(Part2)
                            End If
                        Case "PICTUREBACKGROUND"
                            If Objectname = "SKINPROGRESSBAR" Then
                                GetGUIObject_ByName(Objectname, Index).PictureBackground = ConvertToRealString(Part2)
                            End If
                        Case "PICTUREFOREGROUND"
                            If Objectname = "SKINPROGRESSBAR" Then
                                GetGUIObject_ByName(Objectname, Index).PictureForeground = ConvertToRealString(Part2)
                            End If
                        Case "PICTUREBUTTONNORMAL"
                            If Objectname = "SKINPROGRESSBAR" Then
                                GetGUIObject_ByName(Objectname, Index).PictureButtonNormal = ConvertToRealString(Part2)
                            End If
                        Case "TRANSPARENCYCOLOR"
                            If Objectname = "WINDOW" Then CurWindow.TransparencyKey = Color.FromArgb(Val(Part2))
                            If Objectname = "SKINBUTTON" Or Objectname = "SKINPICTURE" Or Objectname = "SKINPROGRESSBAR" Then
                                GetGUIObject_ByName(Objectname, Index).TransparencyColor = Color.FromArgb(Val(Part2))
                            End If
                        Case "TEXT"
                            If Objectname = "WINDOW" Then CurWindow.Text = ConvertToRealString(Part2)
                            If Objectname = "BUTTON" Or Objectname = "SKINLABEL" Then
                                GetGUIObject_ByName(Objectname, Index).Text = ConvertToRealString(Part2)
                            End If
                            If Objectname = "SKINBUTTON" Then
                                GetGUIObject_ByName(Objectname, Index).ButtonText = ConvertToRealString(Part2)
                            End If
                        Case "TEXTCOLOR"
                            If Objectname = "SKINLABEL" Then
                                Dim mySkinLabel = SkinLabels(Index)
                                mySkinLabel.TextColor = Color.FromArgb(Val(Part2))
                                SkinLabels(Index) = mySkinLabel
                            End If
                        Case "USETRANSPARENCYCOLOR"
                            If Objectname = "WINDOW" And CBool(Part2) = False Then CurWindow.TransparencyKey = New Color ' "New Color" erzeugt eine "leere" Farbe.
                            If Objectname = "SKINBUTTON" Or Objectname = "SKINPICTURE" Or Objectname = "SKINPROGRESSBAR" Then
                                GetGUIObject_ByName(Objectname, Index).UseTransparencyColor = CBool(Part2)
                            End If
                        Case "VISIBLE"
                            If Objectname = "SKINBUTTON" Or Objectname = "SKINPICTURE" Or Objectname = "SKINLABEL" Or Objectname = "SKINPROGRESSBAR" Then
                                GetGUIObject_ByName(Objectname, Index).Visible = CBool(Part2)
                                'Dim GUIObject As Object = GetGUIObject_ByName(Objectname, Index)
                                'GUIObject.Visible = CBool(Part2)
                                'SetGUIObjectProperty_ByName(Objectname, Index, GUIObject)
                            End If
                        Case "VISUALSTEP" ' Prozentwert! -1 = deaktiviert
                            If Objectname = "SKINPROGRESSBAR" Then
                                GetGUIObject_ByName(Objectname, Index).VisualStep = CSng(Part2)
                            End If
                        Case Else
                            ' Nicht-existente Eigenschaft
                            Log("ExecScriptCommand", Loc("Fehler: Eigenschaft existiert nicht.") + " (" + Propertyname + ")", True)
                    End Select
                Catch ex As Exception
                    ' Fehler bei Wertzuweisung an Objekteigenschaft
                    Log("ExecScriptCommand", Loc("Fehler bei Wertzuweisung.") + " (" + ex.Message + ")")
                End Try
            Case "CREATEOBJECT"
                MidPart = ParseMid(ScriptCommand, "(", ")")
                Part1 = ParseLeft(MidPart, ",").ToUpper
                Part2 = ParseRight(MidPart, ",").ToUpper
                If Part2 = "" Then
                    Dim mySkinObjectProbs As New sSkinObjectProbs
                    Select Case Part1
                        Case "BUTTON" ' gewöhnliches Windows-Button
                            Dim myButton As New Windows.Forms.Button()
                            AddHandler myButton.Click, AddressOf Button_Event_Click
                            CurWindow.Controls.Add(myButton)
                            Buttons.Add(myButton)
                            Index = Buttons.Count - 1
                            mySkinObjectProbs.ObjectReference = myButton
                        Case "SKINBUTTON"
                            Dim mySkinButton As New SkinButton.SkinButton
                            AddHandler mySkinButton.ButtonClick, AddressOf SkinButton_Event_Click
                            CurWindow.Controls.Add(mySkinButton)
                            SkinButtons.Add(mySkinButton)
                            Index = SkinButtons.Count - 1
                            mySkinObjectProbs.ObjectReference = mySkinButton
                        Case "SKINPICTURE"
                            Dim mySkinPicture As New SkinPicture.SkinPicture
                            AddHandler mySkinPicture.PictureClick, AddressOf SkinPicture_Event_Click
                            CurWindow.Controls.Add(mySkinPicture)
                            SkinPictures.Add(mySkinPicture)
                            Index = SkinButtons.Count - 1
                            mySkinObjectProbs.ObjectReference = mySkinPicture
                        Case "SKINLABEL"
                            Dim mySkinLabel As New SkinLabel.SkinLabel
                            AddHandler mySkinLabel.TextClick, AddressOf SkinLabel_Event_Click
                            AddHandler mySkinLabel.Hovering, AddressOf SkinLabel_Event_Hovering
                            CurWindow.Controls.Add(mySkinLabel)
                            SkinLabels.Add(mySkinLabel)
                            Index = SkinLabels.Count - 1
                            mySkinObjectProbs.ObjectReference = mySkinLabel
                        Case "SKINPROGRESSBAR"
                            Dim mySkinPBar As New SkinProgressBar.SkinProgressBar
                            mySkinPBar.SmoothMoveEnabled = True
                            AddHandler mySkinPBar.Change, AddressOf SkinProgressBar_Event_Change
                            CurWindow.Controls.Add(mySkinPBar)
                            SkinProgressBars.Add(mySkinPBar)
                            Index = SkinProgressBars.Count - 1
                            mySkinObjectProbs.ObjectReference = mySkinPBar
                        Case Else
                            ' Objecttyp existiert nicht
                            Log("ExecScriptCommand", Loc("Fehler: Objekttyp existiert nicht.") + " (" + Part1 + ")", True)
                    End Select
                    mySkinObjectProbs.ParentWindow = CurWindow
                    mySkinObjectProbs.ObjectType = Part1
                    mySkinObjectProbs.ObjectIndex = Index
                    If Index <> -1 Then SkinObjects.Add(mySkinObjectProbs)
                Else
                    '
                    ' Code für Syntaxvariante 2: CreateObject(Objectname,IndexVariable)
                    '
                End If
            Case "MUTE" ' [optionaler] Parameter 1: keine Angabe=Toggle, 0=Mute, 1=kein Mute
                MidPart = ParseMid(ScriptCommand, "(", ")")
                If MidPart = "" Then
                    acore.SetMuteMode(acore.GetMuteMode() Xor True)
                Else
                    If MidPart = "1" Then
                        acore.SetMuteMode(True)
                    Else
                        acore.SetMuteMode(False)
                    End If
                End If
            Case "SETVOLUME" ' Parameter 1: Angabe der Lautstärke, 0-100 %
                MidPart = ParseMid(ScriptCommand, "(", ")")
                If MidPart = "" Then
                    ' Fehlender Wert für die Lautstärke
                    Log("ExecScriptCommand", Loc("Fehler: Fehlender Wert für Lautstärke.") + " (SetVolume())", True)
                Else
                    Dim Vol As Single
                    Vol = Val(MidPart)
                    If Vol < 0 Or Vol > 100 Then
                        Log("ExecScriptCommand", Loc("Fehler: Ungültiger Wert.") + " (" + Propertyname + ")", True)
                    Else
                        acore.SetVolume(Vol)
                    End If
                End If
            Case "LOADSKIN" ' Paramter 1: Skinname. Lädt den angegebenen Skin.
                MidPart = ConvertToRealString(ParseMid(ScriptCommand, "(", ")"))
                LoadSkin(MidPart)
            Case "GOTOWEBLINK" ' Paramter 1: URL
                MidPart = ConvertToRealString(ParseMid(ScriptCommand, "(", ")"))
                If IsURL(MidPart) Or GetFilenameExtension(MidPart).ToLower = "htm" Then ' Sicherheitsüberprüfung, da sonst externe Programme gestartet werden könntne. Beispiel: "Shutdown.exe"
                    Diagnostics.Process.Start(MidPart)
                End If
            Case "SEARCHLIBRARY" ' Parameter 1: SuchString
                MidPart = ConvertToRealString(ParseMid(ScriptCommand, "(", ")"))
                SearchLibrary(MidPart)
            Case "SHOWINFOTOCURRENTARTIST" ' Zeigt Informationen zum aktuellen Künstler an. Nutzt dafür das Internet.
                If Playlist.CurMediumID <> IsVoid Then
                    Dim SearchString As String
                    SearchString = Media(Playlist.CurMediumID).Artist
                    If SearchString = "" Then SearchString = GetArtistFromFileTitle(Media(Playlist.CurMediumID).FileTitle)
                    SearchString = InputBox(Loc("Informationen zu folgendem Künstler anzeigen:"), Loc("Informationen online abrufen"), SearchString)
                    If SearchString > "" Then
                        SearchString = Replace(SearchString, " ", "_") ' Anpassung an die Wikipedia-Konvention
                        ExecScriptCommand("GOTOWEBLINK(" + "http://de.wikipedia.org/wiki/" + SearchString + ")")
                    End If
                End If
            Case "SHOWMEDIUMPROPERTIES" ' Zeigt die Eigenschaften des akt. Mediums an
                frmMedium.LoadMediumProperties()
                frmMedium.Show()
            Case "SHOWMEDIUMSTORAGEPLACE"  ' Zeigt den Ordner an, in dem die aktuelle Mediendatei gespeichert ist, und selektiert die Mediendatei.
                ShowMediumStoragePlace()
            Case "END"
                acore.Shutdown()
            Case "QUICKPLAY" ' Zeigt Dateiauswahldialog an und spielt gewählte Dateien dann ab
                Quickplay()
            Case "QUICKPLAYURL" ' Insbesondere für Netstreams
                QuickplayURL()
            Case "QUICKPLAYDIR" ' Spielt einen Ordner ab.
                QuickplayDir()
            Case "PLAY" ' [optionaler] Parameter 1: Position des abzuspielenden Playlisten-Elements
                MidPart = ParseMid(ScriptCommand, "(", ")")
                If MidPart = "" Then
                    If Not Playlist.CurMediumID = IsVoid Then
                        PlayMedium_ByPlaylistPosition(Playlist.CurMediumIndex + 1)
                    End If
                Else
                    Index = Val(MidPart) ' Achtung: Index ist kein eigentlicher Index, da nicht nullbasiert! 
                    If Not (Index < 0 Or Index > Playlist.colMediaIDs.Count Or Playlist.colMediaIDs.Count = 0) Then
                        PlayMedium_ByPlaylistPosition(Index)
                    End If
                End If
            Case "PAUSE"
                PausePlaying()
            Case "STOP"
                StopPlaying()
            Case "MINIMIZE" ' Minimiert das Playerfenster
                frmAudia.WindowState = FormWindowState.Minimized
            Case "SHOWPLAYER" ' Nur Sinnvoll, wenn Player minimiert ist.
                frmAudia.WindowState = FormWindowState.Normal
            Case "SHOWINFO"
                frmInfo.Show()
            Case "SHOWSETTINGS"
                frmSettings.Show()
            Case "SHOWSKINS"
                frmSkins.Show()
            Case "SHOWHELP"
                ExecScriptCommand("GoToWeblink(" + AppPath + "\" + LangDir + "\" + Language + "\" + HelpDir + "\index.htm)")
            Case "SHOWCONSOLE"
                frmConsole.Show()
            Case "SHOWSONGTEXT"
                frmSongtext.Show()
            Case "SHOWFAVORITS"
                frmFavorits.Show()
            Case "CLEARPLAYLIST" ' virtuelle Playliste leeren
                ClearPlaylist()
            Case "SHOWPLAYLISTEDITOR"
                frmPlaylist.Show()
            Case "SAVEPLAYLIST"
                SavePlaylist()
            Case "LOADPLAYLIST"
                LoadPlaylist()
            Case "PLAYLISTBACK" ' vorheriges Medium
                PlaylistBack()
            Case "PLAYLISTFORWARD" ' nächstes Medium
                PlaylistForward()
            Case "INCREASEVOLUME" ' Tonausgabe einen "Schritt" lauter
                IncreaseVolume()
            Case "DECREASEVOLUME" ' Tonausgabe einen "Schritt" leiser
                DecreaseVolume()
            Case "STEPBACK" ' Schritt zurück
                StepBack()
            Case "STEPFORWARD" ' Schritt vorwärts
                StepForward()
            Case "ADDCURTOFAVORITS" ' Akt. Medium zu Favoriten hinzufügen
                AddCurToFavorits()
            Case Else
                Log("ExecScriptCommand", Loc("Fehler: Unbekannter Befehl.") + " (" + ScriptCommand + ")", True)
        End Select
    End Function

    ' Führt ein Update der GUI bzw. Teile davon durch.
    ' Die Parameter geben an, welche Teile ein Update benötigen.
    Public Sub UpdateGUI(Optional ByVal UpdateAll As Boolean = True, Optional ByVal UpdateInterval As Boolean = False, Optional ByVal UpdatePlaylist As Boolean = False)
        Dim i As Integer

        If UpdateAll Or UpdatePlaylist Then
            frmMenu.menGotoMedium.DropDownItems.Clear()
            frmMenu.menGotoMedium.Enabled = (Playlist.colMediaIDs.Count > 0 And Playlist.colMediaIDs.Count <= MaxItemCountInGotoMediumMenu) ' (Siehe Definition MaxItemCountInGotoMediumMenu für Beschreibung)
            If frmMenu.menGotoMedium.Enabled Then
                For i = 0 To Playlist.colMediaIDs.Count - 1
                    Dim MenuItem As New ToolStripMenuItem
                    MenuItem.Text = Media(Playlist.colMediaIDs(i)).GetBestTitle()
                    If Playlist.CurMediumIndex = i Then MenuItem.Checked = True
                    frmMenu.menGotoMedium.DropDownItems.Add(MenuItem) ' MenuItem hinzufügen
                    frmMenu.menGotoMedium.DropDownItems(frmMenu.menGotoMedium.DropDownItems.Count - 1).Tag = frmMenu.menGotoMedium.DropDownItems.Count - 1 ' Index im Tag speichern, zur Identifizierung beim Click-Event
                    AddHandler frmMenu.menGotoMedium.DropDownItems(frmMenu.menGotoMedium.DropDownItems.Count - 1).Click, AddressOf menGotoMediumSubItem_Click ' Verknüpfung zur Ereignisbehandlung herstellen
                Next
            End If

            frmPlaylist.UpdatePlaylist()
        End If
        If UpdateAll Or UpdateInterval Then
            ' Menüs:
            With frmMenu
                If Not Playlist.CurMediumID = IsVoid Then
                    If Media(Playlist.CurMediumID).MediumType = eMediumTypes.eNetstream Then
                        RepeatMedium = False
                        IntroMode = False
                        RandomMode = False
                    End If
                    Dim myIsNotNetstream As Boolean = Not Media(Playlist.CurMediumID).MediumType = eMediumTypes.eNetstream
                    .menRepeatMedium.Enabled = myIsNotNetstream
                    .menIntromode.Enabled = myIsNotNetstream
                    .menRandomize.Enabled = myIsNotNetstream
                    .menStepBack.Enabled = myIsNotNetstream
                    .menStepForward.Enabled = myIsNotNetstream
                    .menShowArtistInfo.Enabled = myIsNotNetstream
                    .menShowMediumStoragePlace.Enabled = myIsNotNetstream
                Else
                    .menShowArtistInfo.Enabled = False
                    .menStepBack.Enabled = False
                    .menStepForward.Enabled = False
                    .menShowMediumStoragePlace.Enabled = False
                End If

                .menPlay.Enabled = (Playlist.CurMediumID <> IsVoid)
                .menStop.Enabled = (Playlist.CurMediumID <> IsVoid)
                .menPause.Enabled = (Playlist.CurMediumID <> IsVoid)
                .menBack.Enabled = (Playlist.colMediaIDs.Count > 1)
                .menForward.Enabled = (Playlist.colMediaIDs.Count > 1)
                .menClearPlaylist.Enabled = (Playlist.colMediaIDs.Count > 0)
                .menMenuPortables.Enabled = (Portables.Count > 0)
                .menRemoveMedium.Enabled = (Playlist.CurMediumID <> IsVoid)
                .menMediumProperties.Enabled = (Playlist.CurMediumID <> IsVoid)
                .menShowSongtext.Enabled = (Playlist.CurMediumID <> IsVoid)

                .menRepeatMedium.Checked = RepeatMedium
                .menIntromode.Checked = IntroMode
                .menRandomize.Checked = RandomMode
                .menRepeatPlaylist.Checked = RepeatPlaylist
            End With

            ' GUI-Links:
            For Each myObject In SkinObjects
                Select Case myObject.GUILink
                    Case "PLAYPOSITION"
                        Select Case myObject.ObjectType.ToUpper
                            Case "SKINLABEL"
                                If GetPlayPos() <> IsVoid Then
                                    Dim ts As New TimeSpan(0, 0, GetPlayPos())
                                    myObject.ObjectReference.Text = "[" + Mid(ts.ToString, 4) + "]"
                                Else
                                    myObject.ObjectReference.Text = "[00:00]"
                                End If
                            Case "SKINPROGRESSBAR"
                                myObject.ObjectReference.ShowButton = CBool(Playlist.CurMediumID <> IsVoid)
                                If myObject.ObjectReference.ShowButton Then myObject.ObjectReference.ShowButton = CBool((Media(Playlist.CurMediumID).MediumType <> eMediumTypes.eNetstream Or (Media(Playlist.CurMediumID).HasPlayLen And Media(Playlist.CurMediumID).IsPlayLenTested)) And Media(Playlist.CurMediumID).MediumType <> eMediumTypes.eError)
                                If GetPlayLen() > 0 And GetPlayPos() <> IsVoid Then
                                    myObject.ObjectReference.Value = GetPlayPos() / GetPlayLen() * 100
                                Else
                                    myObject.ObjectReference.Value = 0
                                End If
                            Case Else
                                Log("ExecScriptCommand", Loc("Fehler: Der Objekttyp unterstützt diesen GUILink nicht.") + " (" + myObject.ObjectType + ")", True)
                        End Select
                    Case "TITLETICKER"
                        Select Case myObject.ObjectType.ToUpper
                            Case "SKINLABEL"
                                Dim Title As String
                                If Playlist.CurMediumID = IsVoid Then
                                    Title = Loc("Kein Medium geladen - Verwenden Sie Quickplay, um eine Datei wiederzugeben!")
                                Else
                                    Dim myLen As Single
                                    Dim myLenString As String = ""
                                    myLen = GetMediumPlayLen(Playlist.CurMediumID)
                                    If myLen <> IsVoid Then
                                        Dim ts As New TimeSpan(0, myLen, 0)
                                        myLenString = " [" + FormatDateTime(ts.ToString, DateFormat.ShortTime) + "]"
                                    End If
                                    'Title = "(" + (Playlist.CurMediumIndex + 1).ToString + ") " + Media(Playlist.CurMediumID).GetBestTitle + myLenString
                                    Title = (Playlist.CurMediumIndex + 1).ToString + ". " + Media(Playlist.CurMediumID).GetBestTitle + myLenString
                                    Title = Title + " -- " + Title + " -- " + Title + " -- " + Title + " -- " + Title + " -- " + Title + " -- " + Title + " -- " + Title + " -- " + Title + " -- " + Title + " -- " + Title ' ACHTUNG: Diese Codezeile ist nicht final!!!
                                End If
                                myObject.ObjectReference.Text = Title
                                'frmAudia.ToolTip.SetToolTip(myObject.ObjectReference, Title)
                                'frmAudia.ToolTip.SetToolTip(frmAudia, Title)
                                If myObject.ObjectReference.AutoTicker = False Then myObject.ObjectReference.AutoTicker = True
                            Case Else
                                Log("ExecScriptCommand", Loc("Fehler: Der Objekttyp unterstützt diesen GUILink nicht.") + " (" + myObject.ObjectType + ")", True)
                        End Select
                    Case "VOLUME"
                        Select Case myObject.ObjectType.ToUpper
                            Case "SKINPROGRESSBAR"
                                myObject.ObjectReference.Value = GetVolume()
                            Case Else
                                Log("ExecScriptCommand", Loc("Fehler: Der Objekttyp unterstützt diesen GUILink nicht.") + " (" + myObject.ObjectType + ")", True)
                        End Select
                    Case "COMBINEDPPBUTTON:PAUSE"
                        myObject.ObjectReference.Visible = IsReallyPlaying()
                    Case "COMBINEDPPBUTTON:PLAY"
                        myObject.ObjectReference.Visible = Not IsReallyPlaying()
                        If myObject.ObjectType.ToUpper = "SKINBUTTON" Then
                            If myObject.ObjectReference.Visible Then
                                If Playlist.CurMediumID = IsVoid And myObject.ObjectReference.State <> SkinButton.SkinButton.eStates.Disabled Then myObject.ObjectReference.State = SkinButton.SkinButton.eStates.Disabled
                                If Playlist.CurMediumID <> IsVoid And myObject.ObjectReference.State = SkinButton.SkinButton.eStates.Disabled Then myObject.ObjectReference.State = SkinButton.SkinButton.eStates.Standard
                            End If
                        End If
                    Case "STOP"
                        If myObject.ObjectType.ToUpper = "SKINBUTTON" Then
                            If Playlist.CurMediumID = IsVoid And myObject.ObjectReference.State <> SkinButton.SkinButton.eStates.Disabled Then myObject.ObjectReference.State = SkinButton.SkinButton.eStates.Disabled
                            If Playlist.CurMediumID <> IsVoid And myObject.ObjectReference.State = SkinButton.SkinButton.eStates.Disabled Then myObject.ObjectReference.State = SkinButton.SkinButton.eStates.Standard
                        Else
                            Log("ExecScriptCommand", Loc("Fehler: Der Objekttyp unterstützt diesen GUILink nicht.") + " (" + myObject.ObjectType + ")", True)
                        End If
                    Case ""
                        ' Objekt hat keinen GUILink
                    Case Else
                        ' Unbekannter GUILink
                End Select
            Next
        End If

        If EnableConsole Then frmConsole.UpdateGlobalObs()

        If UpdateInterval = False Then Debug.Print("Update @ " + Now.ToString)
    End Sub

    ' Aktualisiert die Menüeitnräge für die Favoriten (in frmMenu.menMenuFavorits)
    Public Sub UpdateFavoritsMenu()
        If Not Favorits.Count = 0 Then
            frmMenu.menSeparatorFavorits.Visible = True

            For i = frmMenu.menMenuFavorits.DropDownItems.Count - 1 To 0 Step -1
                If Not frmMenu.menMenuFavorits.DropDownItems(i).Tag = "" Then
                    frmMenu.menMenuFavorits.DropDownItems.Remove(frmMenu.menMenuFavorits.DropDownItems(i))
                End If
            Next

            For i = 0 To Favorits.Count - 1
                Dim MenuItem As New ToolStripMenuItem
                MenuItem.Text = Favorits(i).Title
                MenuItem.Tag = i.ToString
                frmMenu.menMenuFavorits.DropDownItems.Add(MenuItem)
                AddHandler frmMenu.menMenuFavorits.DropDownItems(frmMenu.menMenuFavorits.DropDownItems.Count - 1).Click, AddressOf askin.menFavorit_Click ' Verknüpfung zur Ereignisbehandlung herstellen
            Next
        Else
            frmMenu.menSeparatorFavorits.Visible = False
        End If
    End Sub

    ' Ermittelt die ModulID eines Skin-Moduls anhand des Modulnamens
    ' Rückgabewert -1 = nicht gefunden
    Public Function GetSkinModulID_byName(ByVal ModulName As String) As Integer
        Dim i As Integer

        For i = 0 To SkinModuls.Count - 1
            If SkinModuls(i).ModulName.ToUpper = ModulName.ToUpper Then Return i
        Next
        Return -1 ' nicht gefunden
    End Function

    ' Ermittelt die SkinObjectID eines SkinObjects anhand des Typs und des Namens
    ' Rückgabewert -1 = nicht gefunden
    Public Function GetSkinObjectID_byTypeAndName(ByVal ObjectType As String, ByVal ObjectName As String) As Integer
        Dim i As Integer

        For i = 0 To SkinObjects.Count - 1
            If SkinObjects(i).ObjectType.ToUpper = ObjectType.ToUpper Then
                If SkinObjects(i).ObjectName.ToUpper = ObjectName.ToUpper Then Return i
            End If
        Next
        Return -1 ' nicht gefunden
    End Function

    ' Ermittelt die SkinObjectID eines SkinObjects anhand des Typs und des Namens
    ' Rückgabewert -1 = nicht gefunden
    Public Function GetSkinObjectID_byObjectIndex(ByVal ObjectType As String, ByVal ObjectIndex As Integer) As Integer
        Dim i As Integer

        For i = 0 To SkinObjects.Count - 1
            If SkinObjects(i).ObjectType.ToUpper = ObjectType.ToUpper Then
                If SkinObjects(i).ObjectIndex = ObjectIndex Then Return i
            End If
        Next
        Return -1 ' nicht gefunden
    End Function

    ' Ermittelt die SkinObjectID eines SkinObjects anhand eines Verweises auf das Objekt
    ' Rückgabewert -1 = nicht gefunden
    Public Function GetSkinObjectID_byReference(ByVal ObjectReference As Object) As Integer
        Dim i As Integer

        For i = 0 To SkinObjects.Count - 1
            If SkinObjects(i).ObjectReference.Handle = ObjectReference.Handle Then Return i
        Next
        Return -1 ' nicht gefunden
    End Function

    ' Liest die SkinInfos aus einer angegebenen SkinInfodatei aus.
    ' Der Rückgabewert ist eine sSkinInfos-Struktur, die "nothing" ist, wenn das Auslesen fehlschlug.
    Public Function GetSkinInfos(ByVal Filename As String) As sSkinInfos
        Dim SkinInfo As New sSkinInfos

        Try
            Dim reader As Xml.XmlReader
            Dim Element As String = ""

            reader = Xml.XmlReader.Create(Filename)

            While reader.Read()
                Select reader.NodeType
                    Case Xml.XmlNodeType.Element
                        Element = reader.Name.ToLower
                    Case Xml.XmlNodeType.Text
                        If reader.NodeType = Xml.XmlNodeType.Text Then
                            Select Case Element
                                Case "title"
                                    SkinInfo.Title = reader.Value
                                Case "previewpicture"
                                    SkinInfo.PreviewPicture = reader.Value
                                Case "author"
                                    SkinInfo.Author = reader.Value
                                Case "info"
                                    SkinInfo.Info = reader.Value
                            End Select
                        End If
                    Case Else
                        Element = ""
                End Select
            End While

            SkinInfo.InfoFile = Filename

            reader.Close()
            Return SkinInfo
        Catch ex As Exception
            Log("GetSkinInfos()", Loc("Fehler beim Auslesen von Skin-Informationen.") + " (" + Filename + ")", True)
            Return Nothing
        End Try
    End Function

    Private Sub Button_Event_Click(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs)
        SkinEvent_Click(sender, e)
    End Sub

    Private Sub SkinButton_Event_Click(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs)
        SkinEvent_Click(sender, e)
    End Sub

    Private Sub SkinPicture_Event_Click(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs)
        SkinEvent_Click(sender, e)
    End Sub

    Private Sub SkinLabel_Event_Click(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs)
        SkinEvent_Click(sender, e)
    End Sub

    Private Sub SkinProgressBar_Event_Change(ByVal sender As System.Object, ByVal e As System.EventArgs, ByVal NewValue As Single)
        SkinEvent_Click(sender, New System.Windows.Forms.MouseEventArgs(MouseButtons.None, 0, 0, 0, 0))
    End Sub

    ' Ereignisprozedur für die zur Laufzeit generierten SkinObjects.
    ' Ereignis: Click.
    Public Sub SkinEvent_Click(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs)
        Dim Index As Integer

        If e.Button = Windows.Forms.MouseButtons.Right Then ' Rechtsklicks führen immer zum Anzeigen des Menüs
            frmMenu.Menu.Show(sender, New Point(e.X, e.Y))
            Exit Sub
        End If

        Index = GetSkinObjectID_byReference(sender)
        If Index = -1 Then
            ' Fehler: Objekt nicht gefunden
            Log("ExecScriptCommand", Loc("Fehler: Nicht verzeichnete Objektreferenz.") + " (" + sender.ToString + ")")
        Else
            If Not SkinObjects(Index).ClickEvent = "" Then ExecScriptCommand(SkinObjects(Index).ClickEvent, SkinObjects(Index).ParentWindow)
            If SkinObjects(Index).ObjectType = "SKINPROGRESSBAR" And SkinObjects(Index).GUILink = "VOLUME" Then
                SetVolume(SkinObjects(Index).ObjectReference.Value)
            End If
            If SkinObjects(Index).ObjectType = "SKINPROGRESSBAR" And SkinObjects(Index).GUILink = "PLAYPOSITION" Then
                If GetPlayLen() > 0 Then
                    SetPlayPos(SkinObjects(Index).ObjectReference.Value / 100 * GetPlayLen())
                End If
            End If
        End If
    End Sub

    ' Ereignisprozedur für ein zur Laufzeit generiertes Menü-Item.
    ' Ereignis: Click.
    Public Sub menGotoMediumSubItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        ' Folgende Überprüfung ist notwendig:
        ' Es ist unwahscheinlich, aber nicht unmöglich, dass das Menü nach einer Playlisten-Änderung noch nicht aktualiisert wurde.
        ' Die folgende Überprüfung spielt evtl. ein falsches Medium ab, aber es kommt zu keinem Programmfehler.
        If frmMenu.menGotoMedium.DropDownItems.Count = Playlist.colMediaIDs.Count Then
            PlayMedium_ByPlaylistPosition(sender.Tag + 1) ' Im Tag ist der nullbasierte Index des MenuItems gespeichert. Dieser repräsentiert quasi eine Playlisten-Position.
        Else
            ' Fehlerbehanldung? Vllt. Update erzwingen?
        End If
    End Sub

    ' Ereignisprozedur für ein zur Laufzeit generiertes Menü-Item.
    ' Ereignis: Click.
    Public Sub menUsePortable_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        sender.Checked = (Portables(CInt(sender.tag)).Use Xor True)
    End Sub

    ' Ereignisprozedur für ein zur Laufzeit generiertes Menü-Item.
    ' Ereignis: Click.
    Public Sub menFavorit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        PlayFavorit(CInt(sender.tag))
    End Sub

    ' Ereignisprozedur für ein zur Laufzeit generiertes Skin-Object.
    ' Ereignis: Hover.
    Public Sub SkinLabel_Event_Hovering(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Dim Index As Integer

        Index = GetSkinObjectID_byReference(sender)
        If Index = -1 Then
            ' Fehler: Objekt nicht gefunden
            Log("ExecScriptCommand", Loc("Fehler: Nicht verzeichnete Objektreferenz.") + " (" + sender.ToString + ")")
        Else
            If SkinObjects(Index).ObjectType = "SKINLABEL" And SkinObjects(Index).GUILink = "TITLETICKER" Then
                Dim ShowPoint As Point = Windows.Forms.Cursor.Position
                ShowPoint.X = ShowPoint.X - frmAudia.Location.X
                ShowPoint.Y = ShowPoint.Y - frmAudia.Location.Y
                frmAudia.ToolTip.Show(SkinObjects(Index).ObjectReference.Text, frmAudia, ShowPoint, 2000)
            End If
        End If
    End Sub

    ' Gibt ein Objekt, desen ObjectType und Index bekannt sind, als Referenz zurück.
    Public Function GetGUIObject_ByName(ByVal ObjectType As String, ByVal Index As Integer) As Object
        Select Case ObjectType.ToUpper
            Case "BUTTON" ' gewöhnliches Windows-Button
                Dim myButton = Buttons(Index)
                Return myButton
            Case "SKINBUTTON"
                Dim mySkinButton = SkinButtons(Index)
                Return mySkinButton
            Case "SKINPICTURE"
                Dim mySkinPicture = SkinPictures(Index)
                Return mySkinPicture
            Case "SKINLABEL"
                Dim mySkinLabel = SkinLabels(Index)
                Return mySkinLabel
            Case "SKINPROGRESSBAR"
                Dim mySkinPBar = SkinProgressBars(Index)
                Return mySkinPBar
            Case Else
                ' Objekttyp existiert nicht
                Log("ExecScriptCommand", Loc("Fehler: Objekttyp existiert nicht.") + " (" + ObjectType + ")", True)
                Return Nothing
        End Select
    End Function

    Public Sub SetGUIObjectProperty_ByName(ByVal ObjectType As String, ByVal Index As Integer, ByVal GUIObject As Object)
        Select Case ObjectType.ToUpper
            Case "BUTTON" ' gewöhnliches Windows-Button
                Buttons(Index) = GUIObject
            Case "SKINBUTTON"
                SkinButtons(Index) = GUIObject
            Case "SKINPICTURE"
                SkinPictures(Index) = GUIObject
            Case "SKINLABEL"
                SkinLabels(Index) = GUIObject
            Case "SKINPROGRESSBAR"
                SkinProgressBars(Index) = GUIObject
            Case Else
                ' Objekttyp existiert nicht
                Log("ExecScriptCommand", Loc("Fehler: Objekttyp existiert nicht.") + " (" + ObjectType + ")", True)
        End Select
    End Sub
End Module
