﻿Public Class frmFavorits
    Private Sub frmFavorits_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Update_lvFavorits()
    End Sub

    Public Sub Update_lvFavorits(Optional ByVal SelectedIndex As Integer = -1)
        lvFavorits.Items.Clear() ' Nur Items! (nicht lvFavorits.Clear!)
        For i = 0 To Favorits.Count - 1
            lvFavorits.Items.Add(Favorits(i).Title)
            lvFavorits.Items(lvFavorits.Items.Count - 1).SubItems.Add(Favorits(i).Target)
        Next

        If SelectedIndex > -1 And SelectedIndex < lvFavorits.Items.Count Then lvFavorits.Items(SelectedIndex).Selected = True : lvFavorits.Focus()

        UpdateButtons()
    End Sub

    Private Sub DeleteItems()
        If MsgBox(Loc("Sollen die ausgewählten Favoriten wirklich gelöscht werden?"), MsgBoxStyle.YesNo + MsgBoxStyle.Question, Loc("Frage")) = MsgBoxResult.No Then Exit Sub

        If lvFavorits.SelectedIndices.Count > 0 Then ' Wenn mindestens ein Favorit ausgewählt wurde, ...
            For ItemIndex = lvFavorits.SelectedIndices.Count - 1 To 0 Step -1 ' ...alle ausgewählten Favoriten durchlaufen...
                Favorits.RemoveAt(lvFavorits.SelectedIndices(ItemIndex)) ' ... und diese aus der Favoritenliste entfernen.
                lvFavorits.Items.RemoveAt(lvFavorits.SelectedIndices(ItemIndex))
            Next
            UpdateFavoritsMenu()
        End If
    End Sub

    Private Sub butDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butDelete.Click
        DeleteItems()
    End Sub

    Private Sub lvFavorits_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles lvFavorits.KeyDown
        If e.KeyCode = 46 Then ' Taste: Entf
            DeleteItems()
        End If
    End Sub

    Private Sub lvFavorits_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lvFavorits.SelectedIndexChanged
        UpdateButtons()
    End Sub

    Private Sub UpdateButtons()
        butDelete.Enabled = (lvFavorits.SelectedItems.Count > 0)
        butEdit.Enabled = (lvFavorits.SelectedItems.Count = 1)
        butUp.Enabled = (lvFavorits.SelectedItems.Count = 1 And lvFavorits.Items.Count > 1)
        butDown.Enabled = (lvFavorits.SelectedItems.Count = 1 And lvFavorits.Items.Count > 1)
    End Sub

    Private Sub butEdit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butEdit.Click
        Dim Title As String, Target As String
        Dim Index As Integer = lvFavorits.SelectedIndices(0) ' Es gilt die Prämisse, dass es nur einen selektierten Index gibt!

        Target = InputBox(Loc("Bitte geben sie die Adresse des gewünschten Ziels an." + vbCr + vbCr + Loc("Es muss ein Ziel angegeben werden.")), Loc("Ziel"), Favorits(Index).Target)
        If Target = "" Then Exit Sub

        Title = Trim(InputBox(Loc("Bitte geben sie den gewünschten Titel an." + vbCr + vbCr + Loc("Es muss ein Titel angegeben werden.")), Loc("Titel"), Favorits(Index).Title))
        If Title = "" Then Exit Sub

        Dim Favorit As sFavorit = Favorits(Index)
        Favorit.Title = Title
        Favorit.Target = Target
        Favorits(Index) = Favorit

        UpdateFavoritsMenu()
        Update_lvFavorits()
    End Sub


    Private Sub butUp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butUp.Click
        Dim Index As Integer = lvFavorits.SelectedIndices(0) ' Es gilt die Prämisse, dass es nur einen selektierten Index gibt!

        If Index > 0 Then
            Favorits.Insert(Index - 1, Favorits(Index))
            Favorits.RemoveAt(Index + 1)
            Index = Index - 1
        Else ' ansonsten ist Index=0:
            Favorits.Insert(Favorits.Count, Favorits(Index))
            Favorits.RemoveAt(0)
            Index = Favorits.Count - 1
        End If

        UpdateFavoritsMenu()
        Update_lvFavorits(Index)
    End Sub

    Private Sub butDown_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butDown.Click
        Dim Index As Integer = lvFavorits.SelectedIndices(0) ' Es gilt die Prämisse, dass es nur einen selektierten Index gibt!

        If Index < Favorits.Count - 1 Then
            Favorits.Insert(Index + 2, Favorits(Index))
            Favorits.RemoveAt(Index)
            Index = Index + 1
        Else ' ansonsten ist Index=0:
            Favorits.Insert(0, Favorits(Index))
            Favorits.RemoveAt(Favorits.Count - 1)
            Index = 0
        End If

        UpdateFavoritsMenu()
        Update_lvFavorits(Index)
    End Sub

    Private Sub butAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butAdd.Click
        Dim Title As String, Target As String, Pre As String = ""

        If Playlist.CurMediumID <> IsVoid Then Pre = Media(Playlist.CurMediumID).Filename
        Target = InputBox(Loc("Bitte geben sie die Adresse des gewünschten Ziels an." + vbCr + vbCr + Loc("Es muss ein Ziel angegeben werden.")), Loc("Ziel"), Pre)
        If Target = "" Then Exit Sub

        If Playlist.CurMediumID <> IsVoid Then Pre = Media(Playlist.CurMediumID).GetBestTitle()
        If Pre = "" Then Pre = Target
        Title = Trim(InputBox(Loc("Bitte geben sie den gewünschten Titel an." + vbCr + vbCr + Loc("Es muss ein Titel angegeben werden.")), Loc("Titel"), Pre))
        If Title = "" Then Exit Sub

        Dim Favorit As New sFavorit
        Favorit.Title = Title
        Favorit.Target = Target
        Favorits.Add(Favorit)

        UpdateFavoritsMenu()
        Update_lvFavorits()
    End Sub

    Private Sub butPlay_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butPlay.Click
        If Not IsNothing(lvFavorits.FocusedItem) Then ' Wenn ein Favorit ausgewählt wurde, ...
            PlayFavorit(lvFavorits.FocusedItem.Index) ' ... dieses abspielen.
        End If
    End Sub

    Private Sub lvPlaylist_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles lvFavorits.DoubleClick
        butPlay_Click(sender, e)
    End Sub

    Private Sub ExecMyScriptCommand(ByVal ScriptCommand As String)
        askin.ExecScriptCommand(ScriptCommand, Me)
    End Sub
End Class