﻿Public Class frmNotifier
    Public StartTime As Date
    Public NotifyTime As Single = 5
    Public Const NotifyFadeOutTime = 1
    Public Const MaxOpacity = 1 ' 1 = 100%

    Private Sub frmNotifier_BackgroundImageChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.BackgroundImageChanged
        Me.Width = Me.BackgroundImage.Width
        Me.Height = Me.BackgroundImage.Height
    End Sub

    Private Sub frmNotifier_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.Location = New Point(Screen.PrimaryScreen.Bounds.Width - Me.Width, Screen.PrimaryScreen.Bounds.Height - Me.Height)
    End Sub

    ' Zeigt den Notifier mit den angegebenen Parametern an
    Public Sub Notify(ByVal TitleText As String, ByVal myNotifyTime As Single)
        Me.Opacity = MaxOpacity
        Me.Show()
        lblTitle.Text = TitleText
        lblTitle.Refresh() ' notwendig!
        StartTime = Now
        NotifyTime = myNotifyTime
        ControlTimer.Enabled = True
    End Sub

    Private Sub ControlTimer_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ControlTimer.Tick
        If (Now - StartTime).TotalSeconds >= NotifyTime Then
            If (Now - StartTime).TotalSeconds - NotifyFadeOutTime < NotifyTime Then
                Dim value As Single
                If NotifyFadeOutTime > 0 Then
                    value = ((Now - StartTime).TotalSeconds - NotifyTime) / NotifyFadeOutTime
                    Me.Opacity = (1 - value) - (1 - MaxOpacity)
                End If
            Else
                ControlTimer.Enabled = False
                Me.Hide()
            End If
        End If
    End Sub

    Private Sub frmNotifier_MouseClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseClick
        If e.Button = Windows.Forms.MouseButtons.Left Then Me.Hide()
        If e.Button = Windows.Forms.MouseButtons.Right Then frmMenu.Menu.Show(sender, New Point(e.X, e.Y))
    End Sub

    Private Sub lblTitle_MouseClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles lblTitle.MouseClick
        frmNotifier_MouseClick(sender, e)
    End Sub
End Class