﻿Public Class frmPlaylist
    Private Sub frmPlaylist_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        UpdatePlaylist()
    End Sub

    Public Sub UpdatePlaylist()
        lvPlaylist.Items.Clear() ' Nur Items! (nicht lvPlaylist.Clear!)

        Dim i As Integer
        For i = 0 To Playlist.colMediaIDs.Count - 1
            lvPlaylist.Items.Add((i + 1).ToString + ". " + Media(Playlist.colMediaIDs(i)).GetBestTitle())
            If Not Media(Playlist.colMediaIDs(i)).PlayLen = IsVoid Then
                Dim ts As New TimeSpan(0, Media(Playlist.colMediaIDs(i)).PlayLen, 0)
                lvPlaylist.Items(lvPlaylist.Items.Count - 1).SubItems.Add(FormatDateTime(ts.ToString, DateFormat.ShortTime))
            Else
                lvPlaylist.Items(lvPlaylist.Items.Count - 1).SubItems.Add("??:??")
            End If
        Next
    End Sub

    Private Sub ExecMyScriptCommand(ByVal ScriptCommand As String)
        askin.ExecScriptCommand(ScriptCommand, Me)
    End Sub

    Private Sub butSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butSave.Click
        ExecMyScriptCommand("SavePlaylist()")
    End Sub

    Private Sub butLaden_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butLaden.Click
        ExecMyScriptCommand("LoadPlaylist()")
    End Sub

    Private Sub butClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butClear.Click
        ExecMyScriptCommand("ClearPlaylist()")
    End Sub

    Private Sub butPlay_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butPlay.Click
        If Not IsNothing(lvPlaylist.FocusedItem) Then ' Wenn ein Playlistenelement ausgewählt wurde, ...
            ExecMyScriptCommand("Play(" + (lvPlaylist.FocusedItem.Index + 1).ToString + ")") ' ... dieses abspielen.
        End If
    End Sub

    Private Sub lvPlaylist_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles lvPlaylist.DoubleClick
        butPlay_Click(sender, e)
    End Sub

    Private Sub butDelMedium_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butRemoveMedium.Click
        DeleteItems()
    End Sub

    Private Sub lvPlaylist_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles lvPlaylist.KeyDown
        If e.KeyCode = 46 Then ' Taste: Entf
            DeleteItems()
        End If
    End Sub

    Private Sub DeleteItems()
        If lvPlaylist.SelectedIndices.Count > 0 Then ' Wenn mindestens ein Playlistenelement ausgewählt wurde, ...
            For ItemIndex = lvPlaylist.SelectedIndices.Count - 1 To 0 Step -1 ' ...alle ausgewählten Elemente durchlaufen...
                RemoveFromPlaylist_ByPosition(lvPlaylist.SelectedIndices(ItemIndex) + 1, True) ' ... und diese aus der Playliste entfernen.
            Next
            UpdateGUI(True)
        End If
    End Sub
End Class