﻿Public Class frmSkins
    Private SkinList As List(Of sSkinInfos)

    Private Sub butAbort_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butAbort.Click
        Me.Close()
    End Sub

    Private Sub butApply_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butApply.Click
        NowLoadSkin()
    End Sub

    Private Sub lstSkinnames_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles lstSkinnames.DoubleClick
        NowLoadSkin()
    End Sub

    Private Sub frmSkins_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim Dir As New IO.DirectoryInfo(AppPath + "\" + SkinsDir)
        Dim SubDir As IO.DirectoryInfo
        Dim mySkinDir As String

        SkinList = New List(Of sSkinInfos)

        For Each SubDir In Dir.GetDirectories
            Dim SkinInfo As New sSkinInfos

            mySkinDir = SubDir.Name ' Die Ordner enthalten Skins; die Ordnernamen entsprechen den Skinnamen
            SkinInfo = GetSkinInfos(AppPath + "\" + SkinsDir + "\" + mySkinDir + "\" + DefautSkinInfoFile)
            If SkinInfo.Title = "" Then SkinInfo.Title = mySkinDir ' Falls die SkinInfo-DAtei nicht existiert oder beschädigt ist o.ä.
            If SkinInfo.InfoFile = "" Then SkinInfo.InfoFile = AppPath + "\" + SkinsDir + "\" + mySkinDir + "\" + DefautSkinInfoFile ' Wenn die SkinInfos nicht (korrekt) geladen wurden, ist dieser Wert leer. Er wird jedoch später noch unbedingt benötigt.

            lstSkinnames.Items.Add(SkinInfo.Title) ' Die Ordner enthalten Skins; die Ordnernamen entsprechen den Skinnamen
            SkinList.Add(SkinInfo)
        Next

        lstSkinnames.SelectedIndex = 0
    End Sub

    Private Sub lstSkinnames_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lstSkinnames.SelectedIndexChanged
        If lstSkinnames.SelectedIndex > -1 Then
            Dim SkinInfo As sSkinInfos = SkinList(lstSkinnames.SelectedIndex)
            Dim SkinDir As String = GetPath(SkinInfo.InfoFile)

            Try
                If SkinInfo.PreviewPicture > "" Then
                    picPreview.Image = New Bitmap(SkinDir + SkinInfo.PreviewPicture)
                    picPreview.Width = picPreview.Image.Width
                    picPreview.Height = picPreview.Image.Height
                    UpdateControlPositions()
                Else
                    picPreview.Image = Nothing
                End If
                lblAuthor.Text = SkinInfo.Author
                lblInfo.Text = SkinInfo.Info
            Catch ex As Exception

            End Try
        End If
    End Sub

    Private Sub NowLoadSkin()
        Dim mySkinname As String
        mySkinname = SkinList(lstSkinnames.SelectedIndex).InfoFile
        mySkinname = GetPath(My.Computer.FileSystem.GetParentPath(mySkinname), True) ' Trick: GetParentPath() liefert einen Pfad ohne "\" am Ende. GetPath(...,true) kann dies dann als Datei interpretieren und nur den Namen des "letzten" Ordners zurück geben.
        askin.ExecScriptCommand("LoadSkin(" + mySkinname + ")", Me)
    End Sub

    Private Sub frmSkins_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        UpdateControlPositions()
    End Sub

    Private Sub UpdateControlPositions()
        picPreview.Location = New Point(panPreview.Width / 2 - picPreview.Width / 2, panPreview.Height / 2 - picPreview.Height / 2)
    End Sub
End Class