﻿Public Class frmSongtext
    Dim LYRDB As clsLYRDB

    Private Sub frmSongtext_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        LYRDB = New clsLYRDB

        UpdateSongtext()
    End Sub

    Public Sub UpdateSongtext()
        butSaveAs.Enabled = False
        If Playlist.CurMediumID = IsVoid Then Exit Sub

        If LYRDB.ServiceAvailable = False Then
            ' Fehlemeldung?
        Else
            Dim ErrorMsg As String = ""
            Dim Medium As sMedium = Media(Playlist.CurMediumID)
            Dim Title As String = Medium.Title, Artist As String = Medium.Artist
            If Title = "" Then Title = GetSongtitleFromFileTitle(Medium.FileTitle)
            If Artist = "" Then Artist = GetArtistFromFileTitle(Medium.FileTitle)
            If Title = Artist Then ' Trifft zu, wenn der keine Tags ausgewertet werden konnten und der Dateiname z.B. "Symphonie Nr. 23" war. Es wird davon ausgegangen, dass der Dateititel den Songtitel repräsentiert, und nicht etwa den Interpreten.
                GetLYRDBItems(Medium.Title, 1, ErrorMsg)
            Else
                GetLYRDBItems(Medium.Artist + "|" + Medium.Title, 4, ErrorMsg)
            End If
        End If

        If cbResults.Items.Count > 0 Then
            cbResults.SelectedIndex = 0
            butSaveAs.Enabled = True
        Else
            WebBrowser.Navigate(AppPath + "\" + LangDir + "\" + Language + "\songtext_info.htm")
        End If
    End Sub

    Private Sub GetLYRDBItems(ByVal SearchString As String, ByVal SearchType As Byte, ByRef ErrorMsg As String)
        Dim query As String, field As String = "", LastError As String = ""
        Dim n As Integer
        Dim bOk As Boolean

        query = SearchString

        '-- First we store in a variable the type of search.
        '-- See modLyrdb for the value of the constants.

        If SearchType = 1 Then ' if "trackname" selected
            field = LYRDB_TRACKNAME
        ElseIf SearchType = 2 Then ' if "artist" selected
            field = LYRDB_ARTIST
        ElseIf SearchType = 3 Then ' if "both (flexible)" selected
            field = LYRDB_MATCH_FLEX
        ElseIf SearchType = 4 Then ' if "match" selected
            field = LYRDB_MATCH
        End If

        With LYRDB

            '-- Before trying to access LYRDB, check if service is available
            '-- (if not, most likely that your internet connection is down)

            If .ServiceAvailable Then

                '-- We set the "agent" string to send along with the lookup.
                '-- Although it is not mandatory, is important to be set.
                '-- (no particual sintax, the string you want)
                .Agent = "audia7"

                '-- Make the lookup
                bOk = .LyrdbLookup(field, query, LastError)

                If bOk = False Or LastError > "" Then
                    If LastError > "" Then ErrorMsg = LastError
                Else
                    ErrorMsg = vbNullString


                    cbResults.Items.Clear()

                    '-- Results are stored in memory.
                    '-- Now we iterate over them.

                    For n = 0 To .Count - 1
                        '-- With the "result" index, we can access the following
                        '-- properties:
                        '    - LyrdbArtist(index)    - Returns artist for "index"
                        '    - LyrdbTrackname(index) - Returns trackname for "index"
                        '    - LyrdbID(index)        - Returns the LYRDB id for "index"
                        '                              (used to retrieve the lyrics)
                        '    - LyrdbItem(id)         - Returns the lyrics for "id"
                        '
                        '-- NOTE: Collections for Artist, Trackname and ID are
                        '         downloaded when calling to LyrdbLookup.
                        '         Lyrics are downloaded when accessing LyrdbItem
                        '         property.

                        'cbResults.Items.Add(.LyrdbID(n) + vbTab + .LyrdbTrackname(n) + vbTab + .LyrdbArtist(n))
                        cbResults.Items.Add(.LyrdbArtist(n) + " - " + .LyrdbTrackname(n))
                    Next

                End If

            Else
                '-- Oops! Most likely that your internet connection is down.
                MsgBox(Loc("Dieser Webservice ist zurzeit nicht verfügbar. Bitte überprüfen Sie, ob eine Verbindung zum Internet besteht."), vbCritical, "Error")
            End If
        End With
    End Sub

    Private Sub cbResults_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbResults.SelectedIndexChanged
        If cbResults.SelectedIndex > -1 Then ShowLyrics_ByID(cbResults.SelectedIndex)
    End Sub

    ' ID: null-basierte ID der LYRDB-Klasse/Instanz
    Private Sub ShowLyrics_ByID(ByVal ID As Integer)
        Dim lyrics As String, lyricsID As String

        '-- Download the lyrics passing the lyrics ID to
        '-- LyrdbItem function.

        lyricsID = LYRDB.LyrdbID(ID)
        lyrics = LYRDB.GetLyrdbItem(lyricsID)

        WebBrowser.DocumentText = "<font face=""Arial, Verdana"" size=""2"">" + Replace(lyrics, vbCrLf, "<br>") + "</font>"
    End Sub

    Private Sub butMore_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butMore.Click
        ExecMyScriptCommand("GoToWeblink(" + Chr(34) + Loc(LinkLYRDB) + Chr(34) + ")")
    End Sub

    Private Sub ExecMyScriptCommand(ByVal ScriptCommand As String)
        askin.ExecScriptCommand(ScriptCommand, Me)
    End Sub

    Private Sub butUpdate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butSaveAs.Click
        Dim SaveDialog As New SaveFileDialog
        SaveDialog.FileName = cbResults.SelectedItem
        SaveDialog.Filter = "HTML | *.htm"
        SaveDialog.ShowDialog()

        If Not SaveDialog.FileName = "" Then
            Try
                My.Computer.FileSystem.WriteAllText(SaveDialog.FileName, WebBrowser.DocumentText, False)
            Catch ex As Exception
                MsgBox(Loc("Fehler beim Speichern. Das Speichern ist fehlgeschlagen.") + vbCr + vbCr + ex.Message, MsgBoxStyle.Critical, Loc("Fehler"))
            End Try
        End If
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butUpdate.Click
        UpdateSongtext()
    End Sub
End Class